#include <dos.h>
#include <string.h>
#include <alloc.h>
#include <conio.h>
#include <stdio.h>
#include <stat.h>
#include <io.h>
#include <dir.h>
#include <iostream.h>
#include <fcntl.h>
#include <time.h>
#include <math.h>
#include <my_wind.h>

#define  adr_com2   0x2f8
#define  int_com2   3

unsigned int   step=40,              // - 蠣  㬮砭
               step_k=1;        // ---//----  up/down

unsigned char  speed=60;        // cp

short int x=0,y=0;                   // ⥪騥 न 

//===========================================================================
//  ਭ ᨬ  (⢥ ஫)
//---------------------------------------------------------------------------
void wait()
{
  long timeout;
  timeout=clock();
  while((inp(adr_com2+5)&1)==0)
   if((clock()-timeout)==1000) return;

  inp(adr_com2);
}
//===========================================================================
// 樠 COM2
//---------------------------------------------------------------------------
void com_set(void)
{

   outportb(adr_com2+3, 0x80);          // ⠭ ࠢ騩 
   outportb(adr_com2,   0x0C);          // 訩  ᪮ (9600)
   outportb(adr_com2+1, 0x00);          // 訩  ᪮ (9600)

   outportb(adr_com2+3, 0x03);          // ࠢ騩 ॣ
                                        // 8  , 1 ⮯,  ஫
                                        // ⭮

   outportb(adr_com2+1, 0x0);           // ⨫ 뢠

   outportb(adr_com2+4, 0x0);           // ॣ ࠢ 

   inportb(adr_com2);
 }

//===========================================================================
//  O⪫祭e  COM2.
//---------------------------------------------------------------------------
void com_unset(void)
{
   outportb(adr_com2+1, 0x00);          //  뢠  COM
   outportb(adr_com2+4, 0x00);          // ॣ ࠢ 

 }
//===========================================================================
// 뢮 ᨬ  .
//---------------------------------------------------------------------------
void out_sym(unsigned char data)
{
  long timeout=clock();
  while((inportb(adr_com2+5)&0x20)==0)   //   ।
   if((clock()-timeout)==10) return;

  outportb(adr_com2,data);
}
//===========================================================================
// 뢮 ப  COM ( +  "crc" )
//---------------------------------------------------------------------------
void out_str(int *dat_1)
{
  unsigned int crc=0,i=0;
  for(i=0;i<13;i++)
   { crc=crc+dat_1[i];
     out_sym(dat_1[i]);
   }
  unsigned char tmp;
  tmp=char(crc/256);
  out_sym(tmp);
  tmp=char(crc&0x00ff);
  out_sym(tmp);

}
//===========================================================================
void reset (void)
{
  int dat2[]={'A','Z','X',0,0,0,0,0,0,0,0,0,0};
  out_str(&dat2[0]);
}
//===========================================================================
void main_up (unsigned int step_er,unsigned char speed_er)
{
  int  dat2[]={'A','Z','1',(step_er&0x00ff),speed_er,(step_er/256),0,0,0,0,0,0,0};
  out_str(&dat2[0]);
  wait();
  y=y+step_er;
}
//===========================================================================
void main_down (unsigned int step_er,unsigned char speed_er)
{
  int   dat2[]={'A','Z','2',(step_er&0x00ff),speed_er,(step_er/256),0,0,0,0,0,0,0,0};
  out_str(&dat2[0]);
  wait();
  y=y-step_er;
}
//===========================================================================
void kar_left (unsigned int step_er,unsigned char speed_er)
{
  int   dat2[]={'A','Z','3',(step_er&0x00ff),speed_er,(step_er/256),0,0,0,0,0,0,0,0};
  out_str(&dat2[0]);
  wait();
  x=x-step_er;
}
//===========================================================================
void kar_right (unsigned int step_er,unsigned char speed_er)
{
  int   dat2[]={'A','Z','4',(step_er&0x00ff),speed_er,(step_er/256),0,0,0,0,0,0,0,0};
  out_str(&dat2[0]);
  wait();
  x=x+step_er;
}
//===========================================================================
void kar_up (unsigned int step_er,unsigned char speed_er)
{
  int   dat2[]={'A','Z','6',(step_er&0x00ff),speed_er,(step_er/256),0,0,0,0,0,0,0,0};
  out_str(&dat2[0]);
  wait();
}
//===========================================================================
void kar_down (unsigned int step_er,unsigned char speed_er)
{
  int   dat2[]={'A','Z','5',(step_er&0x00ff),speed_er,(step_er/256),0,0,0,0,0,0,0,0};
  out_str(&dat2[0]);
  wait();
}
//===========================================================================
void kar_free (void)
{
  int   dat2[]={'A','Z','7',0,0,0,0,0,0,0,0,0,0};
  out_str(&dat2[0]);
}
//===========================================================================
void stop (void)
{
  int   dat2[]={'A','Z','0',0,0,0,0,0,0,0,0,0,0};
  out_str(&dat2[0]);
}
//===========================================================================
// 樮஢     묨 p⠬ (xx,yy)
// ⭮⥫쭮 砫 न
//---------------------------------------------------------------------------
//void go_xy(short int xx,short int yy)
void go_xy(int xx,int yy,unsigned char d)
{


  unsigned int dx=1,dy=1;

  if((x!=xx)&&(y!=yy)&&(d==1))        //  室
   { float tmp=fabs((yy-y)/(xx-x));

     if(tmp>1){dx=1;dy=ceil(fabs((yy-y)/(xx-x)));}
     if(tmp<1){dy=1;dx=ceil(fabs((xx-x)/(yy-y)));}
//     while((ceil(yy)!=y)||(ceil(xx)!=x))
     while(((yy-y)!=0)||((xx-x)!=0))
     {
       if((yy-y)<0) main_down(dy,speed);
       if((yy-y)>0) main_up(dy,speed);
       if((xx-x)<0) kar_left(dx,speed);
       if((xx-x)>0) kar_right(dx,speed);
     }
   }

  if((yy-y)<0) main_down(((yy-y)*(-1)),speed);
  if((yy-y)>0) main_up(((yy-y)),speed);

  if((xx-x)<0) kar_left(((xx-x)*(-1)),speed);
  if((xx-x)>0) kar_right((xx-x),speed);

}
//===========================================================================
void kont (unsigned char rrr)
{
  main_up(rrr,speed);
  kar_right(rrr,speed);
  main_down(2*rrr,speed);
  kar_left(2*rrr,speed);
  main_up(2*rrr,speed);
  kar_right(rrr,speed);
  main_down(rrr,speed);

}
//===========================================================================

int main(void)
{

 textbackground(BLACK);textcolor(WHITE);
 clrscr();
 asm{ pusha
      mov ah,1
      mov ch,20
      int 16
      popa
     }


 char //*z="Esc-室",
      *z1="pp ࠢ ஬",
      *z2=" ",
      *e="",
      **ee,
      *str[]={
               "砫 न","A",
               "C⮯ !","0",
               " ࠢ騥 - ।","1",
               " ࠢ騥 - ","2",
               "⪠ - ࠢ","3",
               "⪠ - ","4",
               "⪠ - ","6",
               "⪠ - ","7",
               "⪠ - ᢮","9",
               "Go to 0","B",
               "test","8",
               "室","5",
               ""
                 };

  char **adr=&str[0]; // 㪠⥫  ᨢ 㪠⥫
  ee=&e;

 wind q;
 q.winit(1,1,80-2,24-2,z1,ee,BLACK,WHITE,BLACK);
 q.oram(0);
 q.ofon('');

// wind a;
 wind a;
 a.winit(13,4,54,12,z2,adr,RED,BLACK,WHITE);
 a.inbuf();
 a.oram(0);
 a.ofon(' ');
 a.otxt();
 a.ocur();

// 樠 COM2

 com_set();

// ⠭ 砫쭮 ﭨ ஫
 int   dat2[]={'A','Z','0',1,0,0,0,0,0,0,0,0,0};
 out_str(&dat2[0]);

 int bn=1;
 while(bn)
  {gotoxy(1,1);
   printf("x->%i y->%i    ",x,y);

    switch(a.pp())
     { case '5': a.outbuf();    // 室
                 bn=0;
                 break;
       case '1': //a.scur();
                 main_up(step,speed);
                 //a.ocur();
                 break;
       case '2': main_down(step,speed);
                 break;
       case 'A':x=0;y=0;
                 break;
       case '3': kar_right(step,speed);
                 break;
       case '4': kar_left(step,speed);
                 break;
       case '0':
                 stop();
                 break;

       case '6': kar_up(step_k,speed);
                 break;
       case '7': kar_down(step_k,speed);
                 break;
       case '9': kar_free();
                 break;

       case 'B':
                  kar_up(10,speed);
                  if(y>=0) main_down(y,speed);
                    else   main_up(y*(-1),speed);
                  if(x>=0) kar_left(x,speed);
                    else   kar_right(x*(-1),speed);
                  kar_free();
                  break;

       case '8':

//       {R -39 19 926 275}
            kar_up(10,speed);
//	    go_xy(ceil(39/100*27),ceil(50/100*27),0);
            kar_free();
//            kont(10);
            break;

                unsigned int i,ii,sc=27;
float net01[]={5,500,1450,600,1450,650,1400,1750,1400,1800,1450};
float net02[]={6,1800,350,1600,350,1550,300,1150,300,1050,200,1050,50};
float nett03[]={2,700,1450,1700,1450};

float net05_01[]={2,250,50,950,50};
float net05_02[]={6,3300,2675,3300,2650,3000,2650,2950,2600,2900,2550,2900,2450};
float net05_03[]={4,2600,1675,2600,1700,2900,1700,2900,1745};
float net05_04[]={8,1700,1750,1750,1800,2050,1800,2100,1750,2200,1750,2250,1700,2600,1700,2600,1675};

float net04[]={8,3491,1450,3450,1450,3400,1500,2700,1500,2650,1550,2300,1550,2200,1650,2200,1675};
float net06[]={4,1900,1750,1950,1700,2200,1700,2200,1675};
float net07[]={6,1800,250,1600,250,1550,200,1250,200,1150,100,1150,50};

float net08[]={6,1500,550,1200,550,1150,500,850,500,800,550,700,550};
float net09[]={8,2600,1875,2600,1850,2300,1850,2250,1800,2200,1800,2150,1850,2100,1850,2100,1875};
float net10[]={8,500,550,600,550,650,500,750,500,800,450,1400,450,1450,400,1500,350};

float net11[]={7,3392,1450,3350,1450,3350,1400,2600,1400,2550,1450,2200,1450,2200,1475};
float net12[]={6,3500,2450,3400,2450,3350,2400,3250,2400,3200,2450,3100,2450};
float net13[]={9,500,850,600,850,650,800,950,800,1000,750,1450,750,1550,650,1550,500,1500,450};

// GND
float net14[]={6,3000,2350,3050,2400,3050,2500,3200,2500,3250,2450,3300,2450};
float net15[]={10,2000,1450,2100,1450,2150,1400,2500,1400,2550,1350,3350,1350,3400,1400,3700,1400,3750,1450,3786,1450};
float net16[]={7,900,850,1000,850,1050,800,1650,800,1750,700,1750,500,1800,450};
float net17[]={5,150,50,200,0,1200,0,1250,0,1250,50};
float net18[]={4,2150,50,1900,50,1850,0,1200,0};


float kontur[]={5, -800,-550, -800,3450, 4100,3450, 4100,-550, -800,-550};

//solder float net04[]={5,3100,1950,3100,1850,3150,1800,3150,1450,3196,1450};
//float net05[]={28,700,850,700,650,750,600,750,150,850,50,950,50,
//                 1800,550,1750,550,1750,500,1750,100,1650,0,1000,0,950,50,
//                1700,1750,1700,1550,1750,1500,1750,500,
//                2900,1745,2900,1750,2900,1850,2850,1900,2850,2000,2900,2050,
//                2900,2450,2600,1475,2600,1500,2600,1650,2600,1675};

//float *net[]={ &net01[0],&net02[0]},&nett03[0],&net04[0],&net05[0] } ;
int net_k=22;
float *net[22]={&net01[0],&net02[0],&nett03[0],&net04[0],&net05_01[0],
                &net05_02[0],&net05_03[0],&net05_04[0],
                &net08[0],&net09[0],&net10[0],
                &net11[0],&net12[0],&net13[0],
                &net14[0],&net15[0],&net16[0],
                &net17[0],&net18[0],
                &net06[0],&net07[0],&kontur[0] } ;


            for(ii=0;ii<net_k;ii++)
             {kar_up(10,speed);
//  gotoxy(1,3+ii);
//  printf("%i %i ",(*(net[ii]+1))/100,(*(net[ii]+2))/100);
              go_xy((*(net[ii]+1))/100*27,(*(net[ii]+2))/100*27,0);
              kar_free();
//              kont(8);
//            kont(6);
//            kont(5);
               for(i=1;i<(*net[ii]);i++)
               {
//              printf("%d %d ",(*(net[ii]+1+i*2))/100,(*(net[ii]+2+i*2))/100);
                go_xy(ceil((*(net[ii]+1+i*2))/100*27),ceil((*(net[ii]+2+i*2))/100*27),1);
               }
//              kont(8);
//            kont(6);
//            kont(5);
              }

                 break;

       default:
                 break;
      }
  }

 int dat3[]={'A','Z','0',0,0,0,0,0,0,0,0,0,0};
 out_str(&dat3[0]);

 com_unset();

 textbackground(BLACK);
 textcolor(RED);
 clrscr();
 gotoxy(1,25);

 return 0;
}

