/*
 * :                       ணࠬ஢
 *                            ᫥⥫쭮   -
 *                             MS-DOS.
 *  :             让 
 * ࠭᫨஢/: CL /AL /Gs serio.c
 */
/*----------------------------------------------------------*/
#include <stdio.h>
#include <ctype.h>
#include <dos.h>
#include <bios.h>
#include <conio.h>

#define  TRUE 1
#define  FALSE 0
#define  EOS  '\0'

#define  CONTROL(x)  (x-0x40)
#define  ESC_KEY     CONTROL('[')

/* । 㭨樮 ࠬ */
#define COM_PARAMS (_COM_CHR8 | _COM_STOP1 | \
                        _COM_NOPARITY |_COM_1200)

/* । ࠧ ਥ  ।饣 ஢ */
#define RXQSIZE 512
#define TXQSIZE 512

/* ।  ணࠬ㥬 ஫
 * 뢠 8259A
 */
#define P8259_0 0x20    /* ॣ ࠢ 뢠 */
#define P8259_1 0x21    /* ॣ ᪨ 뢠 */
#define END_OF_INT 0x20 /*  । EIO */

/* ।  ASCII XON  XOFF */
#define XON_ASCII   (0x11)
#define XOFF_ASCII  (0x13)

/*     BIOS   400h */
#define BIOS_DATA  ((int far *0(0x400000L))

/* ᮬ 㭨樮   ⪮ 楫
 * 'comport'.  ६ 樠 ⥭ 
 *   BIOS  ᥣ 040.
 */
#define IER (comport + 1) /* ॣ ࠧ襭 뢠 */
#define IIR (comport + 2) /* 䨪 뢠 */
#define LCR (comport + 3) /* ॣ ࠢ ॣ஬ */
#define MCR (comport + 4) /* ॣ ࠢ  */
#define LSR (comport + 5) /* ॣ ﭨ  */
#define MSR (comport + 6) /* ॣ ﭨ  */

/*  ࠧ襭 ⤥ 뢠 */
#define RDAINT  1
#define THREINT 2
#define RLSINT  4
#define MSINT   8

/* 祭 ॣ ࠢ  */
#define MCRALL  15  /* (DTR, RTS, OUT1  OUT2 = 1) */
#define MCROFF  0   /*  襭 */

/* 祭 ॣ ࠧ襭 뢠  
 * 祭/몫祭
 */
#define IERALL  (RDAINT+THREINT+RLSINT+MSINT)
#define IEROFF  0

/* ᪮쪮 ᮪   뢠 */
#define THEREOFF 0xfd

/*  䨪 뢠 */
#define MDMSTATUS   0
#define TXREGEMPTY  2
#define RXDATAREADY 4
#define RLINESTATUS 6

/*  ࠢ ⮪ XON/XOFF */
#define XON_RCVD   1
#define XOFF_RCVD  0
#define XON_SENT   1
#define XOFF_SENT  0

/* 訩  訩 樥  ਣ xon-xoff */
#define HI_TRIGGER(x)  (3*x/4)
#define LO_TRIGGER(x)  (x/4)

/* 㭪 祭 㫥  楫 */
#define bit0(i)   (i & 0x0001)

/* ப  祭 뢠, " ࠧ襭
 * 뢠" ண "i",  ⨢ 砥  頥-
 * .  ਬ, 뢠 THRE 頥, ᫨ XOFF -
 * 祭  㤠 ⥬.
 */

#define turnon_int(i,j) \
        if(((j=inp(IER))&i)==0)outp(IER,(j|i))

#define report_error(s)  fprintf(stderr,s)
typedef struct QTYPE  /*    । */
{
       int  count;
       int  front;
       int  rear;
       int  mexsize;
       char *data;
}   QTYPE;

static char rxbuf[RXQSIZE], txbuf[TXQSIZE];

static QTYPE rcvq = {0, }-1, -1, RXQSIZE, rxbuf},
             trmq = {0, }-1, -1, TXQSIZE, txbuf};

/* ਧ 饣 ﭨ */
int s_linestatus, s_modemstatus;

static  QTYPE *txq = &trmq, *rxq = &rcvq;
static  short comport=0,
              enable_xonxoff = 1,
              rcvd_xonxoff = XON_RCVD,
              sent_xonxoff = XON_SENT,
              send_xon = FALSE,
              send_xoff = FALSE,
	      int_number = 12, // ;
              int_enable_mask = 0xef,
              int_disable_mask = 0x10;

/* ⨯ 㭪権 */
int s_sendchar(int);
int s_rcvchar(void);
int s_setup(short, unsigned);
int s_cleanup(void);

char *q_getfrom( QTYPE *, char *);
int   q_puton( QTYPE *, char *);

void interrupt far s_inthndlr(void);

static void  s_rda(void);
static void  s_trmty(void);
static void  (interrupt far *old_handler)();
/*----------------------------------------------------------*/
main(int argc, char **argv)
{
    int ch, port_number = 0;

/*      ப */
    if(argc > 1) port_number = atoi(argv[1]) - 1;
    printf("\nSERIO -- ᫥⥫ /뢮 \
c ࠬࠬ 1200,8,N,1 १  COM%d\n", port_number+1);
    printf("\n ...\n");

/* 砫 ⠭ ᫥⥫  */
    s_setup(port_number, COM_PARAMS);

/* ᫥騩 ᪮ 横  ନ.
 *  Escape 㦨  饣   .
 */

    while (TRUE)
    {
         if ((ch = s_rcvchar()) != -1) putch(ch);
         if ( kbhit() != 0)
         {
             ch = getch();
             if (ch == ESC_KEY)
             {
                   s_cleanup();
                   return;
             }

             else
                 s_sendchar(ch);
         }     /*  ஢ન kbhit() */
    }
}
/*---------------------------------------------------------*/
/* s _ i n t h n d l r
 * ࠡ稪  뢠 ᫥⥫쭮 .
 */
void interrupt far s_inthndlr(void)
{
    int c;
    registr int int_id, intmask;

/*  ࠧ 뢠 */
    _enable();

    while (TRUE)
    {
/*  ॣ 䨪樨 뢠 , IIR */
       int_id = inp(IIR);
       if (bit0(int_id) == 1)
       {
/* ᫨  0 - 1,  뢠  . ࠢ ண-
 * ࠬ㥬 ஫ 뢠 ᨣ  " 뢠-
 * "  .
 */
           outp(P8259_0, END_OF INT);
           return;
       }
       if (int_id >= RXDATAREADY)
                       turnon_int(THEREINT,intmask);
/* ࠡ 뢠  ᮮ⢥⢨  䨪஬.
 * 騩 祭 ⠢  ᮮ⢥⢨  ⠭
 * ਮ.
 */

        switch (int_id)
        {
           case MDMSTATUS:    /*  ﭨ  */
                              s_modemstatus = inp(MSR);
                              break;
           case TXREGEMPTY:   s_trmty();
                              break;
           case RXDATAREADY:  s_rda();
                              break;
           case RLINESTATUS:  /*  ﭨ  */
                              s_linestatus = inp(LSR);
                              break;
/* ய, ᫨ 䨪    
 * ᫥ */
        }
    }
}
/*---------------------------------------------------------*/
/* s _ r d a
 * ࠡ 뢠 "㯭   ਥ"
 */
static void s_rda(void)
{
    registr int intmask;
    char c;
/*   㭨樮  */
    c = inp(comport);
    if(enable_xonxoff) {
       if (c == XON_ASCII) {
             rcvd_xonxoff = XON_RCVD;
/*  뢠 THRE, ᫨  몫祭. */
             turnon_int(THREINT,intmask);
             return;
       }
       if(c == XOFF_ASCII) {
             rcvd_xonxoff = XOFF_RCVD;
/*  뢠 THRE */

             intmask = inp(IER);
             if (intmask & THREINT0
                       outp(IER, intmask & THREOFF);
             return;
        }
    }
    q_puton(rxq, &c);
/* ஢,    । (75%) */
    if(enable_xonxoff) {
       if(rxq->count >= HI_TRIGGER(RXQSIZE) &&
          sent_xonxoff != XOFF_SENT ) {
/* ⠭ 䫠  ࠢ XOFF */
          send_xoff = TRUE;
/*  뢠 THRE ⠪, ⮡ ᫠ XOFF */
          turnon_int(THREINT,intmask);
      }
   }
}
/*---------------------------------------------------------*/
/* s _ t r m t y
 * ࠡ 뢠 "ॣ ࠭ ।
 * ᢮"
 */
static void s_trmty(void)
{
    char c;
    registr int ierval;

    if (send_xoff == TRUE) {
        outp(comport, XOFF_ASCII);
        send_off = FALSE;
        sent_xonxoff = XOFF_SENT;
        return;
    }
    if (send_xon == TRUE) {
        outp(comport, XON_ASCII);
        send_xon = FALSE;

        sent_xonxoff = XON_SENT;
        return;
    }
/*  ᨬ  ॣ ࠭ । */
    if( q_getfrom(txq, &c) != NULL){
        outp(comport, c);
        return;
    }
/* 祣 뫠 --  뢠 THRE */
    ierval = inp(IER);
    if (ierval & THREINT) outp(IER, ierval & THREOFF);
}
/*---------------------------------------------------------*/
/* s _ s e t u p
 * ⠭   裡.
 *  1, ᫨ ⠭ 諠 ᯥ譮,  ⨢
 * 砥  0.
 */
int s_setup(short port_number, unsigned commparams)
{
    int intmask;

    if (port_number < 0 || port_number > 1)
        report_error("  !\n");

/*    ᫥⥫쭮  
 *   BIOS */
    comport = *(BIOS_DATA + port_number);
    if (comport == 0)
    {
        report_error("BIOS    !\n");
        return(0);
    }

/* ⠭ ᪨  ணࠬ㥬 ஫
 * 뢠 8259A.  ࠧ襭 뢠 
 *  ᪠ ᪨ 㬭  ᪮ ॣ

 *  21h.  饭, ᪨ ᫮ 
 * 饭  ᪮ ॣ.  뢠
 * ।  8 + ஢ IRQ 뢠.
 * 㭨樮  1  IRQ 4,  2 
 * IRQ 3.
 */
    if (port_number == 0)
    {
        int_enable_mask = 0xef;
        int_disable_mask = 0x10;
        int_number = 12;

    }
    if (port_number == 1)
    {
        int_enable_mask = 0xf7;
        int_disable_mask = 8;
        int_number = 11;
    }

/*   ண 뢠  ࠭ . */
    old_handler = _dos_getvect(int_number);

/* ⠭  ࠡ稪   s_inthndlr.
 *  뢠  ᬥ ࠡ稪.
 */
    _disable();
    _dos_setvect(int_number, s_inthndlr);
    _enable();

/* ⠭ 㭨樮 ࠬ */
    _bios_serialcom(_COM_INIT, port_number, commparams);

/* 樠஢ 䫠 XON/XOFF */
    rcvd_xonxoff = XON_RCVD;
    if (sent_xonxoff == XOFF_SENT)
        send_xon = TRUE;

    else
        send_xon = FALSE;
        send_xoff = FALSE;

/*  뢠 㭨樮  
 * ⠭ 8259A.
 */
    _disable();
/* ⠭ ॣ ࠢ  ( = MCR) */
    outp(MCR, MCRALL);

/*   뢠 ᫥⥫쭮  */
    outp(IER, IERALL);

/*  ॣ ᪨ 뢠 8259A   
 * ⭮ ᫥ ᪮ 㬭  _int_enable_mask.
 */
    intmask = inp(P8259_1) & int_enable_mask;
    outp(P8259_1, intmask);

    _enable();

    return(1);
}
/*---------------------------------------------------------*/
/* s _ c l e a n u p
/*  ᫥ ᥠ 裡.   뢠. */
int s_cleanup(void)
{
    int intmask;

/* 몫 뢠 ᫥⥫쭮  */
    _disable();
/*   ॣ ࠧ襭 뢠  */
    outp(IER, IEOFF);

/*    ॣ ࠢ  */
    outp(MCR, MCROFF);

/* ⥬  ᯮ ஫஬ 8259A
 * 뢠 ᫥⥫쭮 .
 */
    intmask = inp(P8259 _1) | int_disable_mask;
    outp(P8259_1, inymask);

/* ⠭ ࢮ砫  뢠 */
    _dos_setvect(int_number, old_handler);

/*  ࠧ 뢠 */
    _enable();
}
/*---------------------------------------------------------*/
/* s _ s e n d c h a r
 *  ᨬ  ।  ।.  1, ᫨
 *   浪,  ⨢ 砥  0.
 */
int s_sendchar(int ch)
{
    int retval, intmask;
    _disable();
    retval = q_puton(txq, (char *)&ch);
    _enable();
/*  뢠THRE  ⮬ 砥, ᫨  몫祭
 *   祭 XOFF.
 */
    if (rcvd_xonxoff != XOFF_RCVD)
        turnon_int(THREINT,intmask);
    return(retval);
}
/*---------------------------------------------------------*/
/* s _ r c v c h a r
 *  ᨬ  ।  ਥ.
 *  1, ᫨ । .
 */

int s_rcvchar(void)
{
    int ch, intmask;
/* ᫨ ࠭  ᫠ ᨣ XOFF,    ࠢ
 * XON.
 */
    if(enable_xonxoff)
    {
    if(rxq->count <= LO_TRIGGER(RXQSIZE) &&
         sent_xonxoff != XON_SENT )
         {
            send_xon = TRUE;
            turnon_int(THREINT,intmask);
         }
    }
    _disable();
    if (q_getfrom(rxq, (chr *)&ch) == NULL)
    {
        _enable();
        return(-1);
    }
    else
    {
    _enable();
    return(ch);
    }
}
/*--------------------------------------------------------*/
/* q _ g e t f r o m
 * ஢ ᫥騩    । 
 * । ⮯.   㪠⥫
 *   .
 */
char *q_getfrom( QTYPE *queue, char *data)
{
    char *current;
    current = NULL;

    if(queue->front == -1) return(current);
/*  ⨢ 砥 ᪠  */
    current = &(queue->data[queue->front]);
    *data = *current;
    queue->count--;
    if(queue->count == 0)
    {
/* । .  砫,    */

       queue->front = queue->rear = -1;
       return(current);
    }
/*  砫   ஢  横᪨
 * 室.
 */
    if(queue->front == queue->maxsize-1)
       queue->front = 0;
    else
       queue->front++;
    return(current);
}
/*--------------------------------------------------------*/
/* q _ p u t o n
 *     ।.
 */
int q_puton(QTYPE *queue, char *data)
{
/* 砫 ஢ ⥯  ।.
 * ᫨  ,   0.
 */
    if(queue->count == queue->maxsize) return(0);
/*  ⨢ 砥 ⠭    ஢
 * ஢  横᪨ 室.
 */
    if(queue->rear == queue->maxsize-1)
       queue->rear = 0;
    else
       queue->rear++;
/* ࠭ ᨬ  । */
    queue->data[queue->rear] = *data;
    queue->count++;
    if(queue->front == -1) queue->front = 0;
    return(1); /* ᯥ譮 ⠢  */
}

/*

                       祭

     ⮩    ᬮ७  ࠪ⨪  ।
᫥⥫쭮   ⥬ MS-DOS   ।⠢  ⮤
 ணࠬ஢.  ᮤন  㭨樮
ணࠬ,  ᠭ  Microsoft C 5.0,  樨 ॠ-
樨  ⮤  ࠪ⨪. ணࠬ஢ ᫥⥫쭮-
    ࠢ塞  뢠  /뢮  믮
᫥騬 ࠧ:

    1.     ࠭ 㭨樮 
          BIOS  ᥣ 40h   ᬥ饭 0.
    2. ᯮ 㭪 MS-DOS 35h,    ன  -
       ணࠬ 㦨 뢠     뢠,
       ᮮ⢥饣  ,  ࠭ .
    3. ᯮ 㭪 MS-DOS 25h, ⠭   -
          ᮡ⢥ ணࠬ 㦨 뢠-
       .
    4.   ᯮ짮 㭪樨 BIOS 14h ⠭ 㭨-
        ࠬ .
    5. ⠭ । ਥ  ।  ᮤঠ 室-
         室 ᨬ.
    6.   ॣ ࠢ  室 ᨣ
       (ਬ,  DTR - ନ ⮢  RTS -   ।-
       ).
    7.   뢠  (⠭ ⮢  0 
       3  ॣ ࠧ襭 뢠  1).
    8.     OUT2  ॣ ࠢ  
       ࠧ襭 뢠 ᫥⥫쭮 .
    9. ணࠬ஢ ஫ 8259A  ᯮ  -
       뢠  IRQ ⮣  (⥬ ⠭ ᮮ⢥-
       饣  ॣ ᪨ 뢠, 㯭 १ -
         21h,  0).

     믮   権,  ᫨ 짮⥫ 蠥
ࢠ ᥠ ࠡ,    맢 ணࠬ  "-
". ⪠ 믮 ᫥騬 ࠧ:

    1. 몫 뢠 ᫥⥫쭮 .
    2.   ॣ ࠢ .
    3. ⠭  ணࠬ ࠡ⪨ 뢠.
    4. ᪨஢ 뢠  ⮣ IRQ  8259A.

*/